{-
Author and Licence here or use stack/cabal init.
-}

-- Your comment about the function here
-- Use Types first, then explain why you need it (if you have time enough)
change word nb = take (nb-1) word ++ "-" ++ drop nb word

-- Types: usually I am just copy pasting ```:t fun``` in ghci
-- as minimal documentation
dropElem [] _ = []
dropElem (x:xl) nb
    | x == nb = xl
    | otherwise = x : dropElem xl nb

------------------------------------------------------------------------
-- TODO at release: put tests in specific folder to be executed with stack/cabal command
testResult :: String -> String -> String
testResult xl sol = testPlace sol xl (testResult' xl sol)
    where
        testResult' [] _ = []
        testResult' _ [] = []
        testResult' (x:xl) (s:sl)
            | x == s    = 'O' : testResult' xl sl
            | otherwise = 'X' : testResult' xl sl
        testPlace [] _ _ = []
        testPlace _ [] _ = []
        testPlace xl (s:sl) (w:wl)
            | w == 'O'                  = 'O' : testPlace (dropElem xl s) sl wl
            | w == 'X' && s `elem` xl   = '-' : testPlace (dropElem xl s) sl wl
            | otherwise                 = 'X' : testPlace xl sl wl

testWin :: String -> Bool
testWin = all (== 'O')

------------------------------------------------------------------------

game :: String -> IO()
game x = do
    putStrLn $ "Your turn (the word have " ++ show (length x) ++ " letters):"
    line <- getLine -- here how to enable backspace in ghci ?
    if null line || (length line /= length x)
        then game x
        else do
            let res = testResult line x
            putStrLn res
            if testWin res
                then return ()
                else game x

-- put this in stack/cabal app/main.hs
-- then we can execute it after compiling or with specific cabal/stack command
main :: IO ()
main = do
    putStrLn "Choose a level (1-6)"
    nb <- getLine
    if null nb
        then return ()
        else do
            -- use shuffle of gargantext-prelude here
            let lst = ["crane", "blond", "brave", "aussi", "gagne", "texte"]
            game (lst!!(read nb - 1))
